<?php
// $Id: views.inc,v 1.1.2.1 2007/04/12 03:16:32 sun Exp $

function localizer_tables() {
  $tables['localizernode'] = array(
    'name' => 'localizernode',
    'join' => array(
      'left' => array(
        'table' => 'node',
        'field' => 'nid'
      ),
      'right' => array(
        'field' => 'nid'
      ),
    ),
    'fields' => array(
      'locale' => array(
        'name' => 'Localizer : content locale',
        'handler' => 'views_handler_localizer_contentlocales',
        'option' => array(
          '#type' => 'select',
          '#options' => array(
            'text_without_flag' => t('Text without flag'),
            'text_with_flag' => t('Text with flag'),
            'only_flag' => t('Only flag')
          ),
        ),
        'sortable' => true,
        'addlfields' => array('locale')
      ),
    ),
    'sorts' => array(
      'name' => array('locale' => 'Node : Locale')
    ),
    'filters' => array(
      'localizer_contentlocales' => array(
        'name' => 'Localizer : content locale',
        'operator' => array('is' => t('is')),
        'list' => 'views_handler_localizer_filter_contentlocales_list',
        'handler' => 'views_handler_localizer_filter_contentlocales',
      ),
      'localizer_support' => array(
        'name' => 'Localizer : activate generic support',
        'operator' => array('is' => t('is')),
        'handler' => 'views_handler_localizer_generic_support',
        'list' => array('active' => t('Active'), 'inactive' => t('Inactive')),
        'list-type' => 'select',
      )
    ),
  );
  return $tables;
}

function views_handler_localizer_contentlocales($fieldinfo, $fielddata, $value, $data) {
  static $languages;
  if (!$languages) $languages = localizer_available_locales();
  $lang      = $value;
  $langname  = t('@language', array('@language' => $languages[$value]));
  if ($fielddata['options'] == 'text_with_flag') {
    $flag      = theme('localizer_flag', $lang, $langname, 'content');
    $separator = variable_get('localizer_block_content_flagseparator', ' ');
    $separator = ($langname != '' && $flag != '') ? $separator : '';
    return $flag . $separator . $langname;
  }
  else if ($fielddata['options'] == 'only_flag') {
    $flag     = theme('localizer_flag', $lang, $langname, 'content');
    return $flag;
  }
  else {
    return t('@language', array('@language' => $languages[$value]));
  }
}

function views_handler_localizer_filter_contentlocales_list() {
  static $languages;
  if (!$languages) {
    $languages = localizer_available_locales();
  }
  return $languages;
}

function views_handler_localizer_filter_contentlocales($op, $filter, $filterinfo, &$query) {
  $contentlocales_sql = "'-'"; // 'Any' always included
  if ($filter['value']) {
    if (is_array($filter['value'])) {
      $values = $filter['value'];
    }
    else if (is_string($filter['value'])) {
      $values = explode(',', $filter['value']);
    }
    foreach ($values as $key => $value) {
      $contentlocales_sql .= ", '$value'";
    }
  }
  $query->ensure_table('localizernode');
  $query->add_where('localizernode.locale IN ('. $contentlocales_assql .') OR localizernode.locale IS NULL');
}

function views_handler_localizer_generic_support($op, $filter, $filterinfo, &$query) {
  if ($filter['value'] == 'active') {
    $query->ensure_table('localizernode');
    $query->add_where('localizernode.locale IN ('. localizer_get_enabled_locales() .') OR localizernode.locale IS NULL');
  }
}

